#!/usr/bin/perl
# (c) MandrakeSoft, Chmouel Boudjnah <chmouel@mandrakesoft.com>, 
# DindinX (David Odin) <odin@mandrakesoft.com>
# Copyright under GPL blah blah blah.
## Give the string to DrakConf, c is too suck to parse string :).

use Config;
use Getopt::Long;

my $conf_files;
my $xterm = '/usr/X11R6/bin/xterm -fn 9x15 -bg black -fg white -e';
my $arch = $Config{'archname'}; $arch =~ s|-.*||;


(my $LANG = $ENV{'LANGUAGE'} || $ENV{'LC_ALL'} || $ENV{'LC_MESSAGES'} || $ENV{'LANG'}) =~ s|_.*||;

if ( -r '/etc/sysconfig/system') {
  $expert = cat_("/etc/sysconfig/system") =~ /^TYPE="?expert/m; #";
}

my @getopt_args = ('t|test','d|dir=s','e|expert','h|help');
GetOptions(\%options, @getopt_args) ||  usage(1);
usage() if $options{h};

$expert++ if $options{e};
$conf_dir = $options{d} if $options{d};
$conf_dir = $options{t} ? './po/' : '/etc/wizdrake/' unless $conf_dir;

do {print "ERROR = ERROR\n"; exit 1}
  unless -d ($conf_dir);

opendir D, $conf_dir or die "Can't open $conf_dir\n";
for (readdir(D)) {
    my $file = $_;
    next if /^(\.\.?|CVS)/;
    process ("$conf_dir$file");
}

sub process {
    my $f = shift @_;
    open(FH, $f);
    $/="";

    while (<FH>) {
	my ($program, $icon_name);
	&get_arch;
	eval ($1) if /EVAL=(.*)$/m;
	s|\"||g;

	$program=$1 if /PROGRAM=(.*)/ && !$program; 
	(my $t = $program) =~ s| .*||; next unless  -x $t || $options{t};
	next if /^DANGEROUS=YES/m && !$expert;

	&parse_lang(NAME);
	print "PROGRAM=$program\n";
	$icon_name ? print "ICON_NAME=$icon_name\n" : &parse_entry(ICON_NAME);
	&parse_lang(DESC);
    }
    close FH;
}

sub parse_lang {
  my $s = shift @_;
  if (/$s\($LANG\)=(.*)/) { print "$s=$1\n"; } elsif (/$s=(.*)/) { print "$s=$1\n"; }
}

sub parse_entry {
  my $s = shift @_;  print "$s=$1\n"  if /$s=(.*)/; return $1;
}

sub cat_ { local *F; open F, $_[0] or $_[1] ? die "cat of file $_[0] failed: $!\n" : return; my @l = <F>; wantarray ? @l : join '', @l }

sub get_arch { next if /Exclusivearch=\s*(.*)/ and $1 !~ $arch;}


sub usage {
  my $e = shift @_;
  $0 =~ s|.*/||;
  print {  $e ? STDERR : STDOUT } << "EOF";
Usage: $0 [-dteh] [ -d DIR ]
Text parser for wizdrake.

  -d DIR, --dir=DIR:	Specify an alternarte config dir.
  -t,	     --test:	Launch in test mode.
  -e,	   --expert:	Enter in expert mode.
  -h,        --help:	Display this message.      

EOF
  exit($e);
}
